#! /usr/bin/env python
# -*- coding: utf-8 -*-
import shutil
import commands
import string
import filecmp
import ftplib
import socket
from datetime import datetime
import sys
import os
from lscLib import ftpName, adler, pLog,rootDir, cPaths,confFileDict
wersja = '20150402-03'
version=wersja
#wywolanie serwerowe
#lscGlue.py musi sam sobie czytać konfigurację, bo dla każdego licznika jest inna
#lscGlue.py, namePrefix,katalogKatalogowLicznikow
'''
sudo /opt/zeletronik/bin/lscGlue.py gpio /opt/zeletronik 6
20150402
jak nie ma nowej listy plików to sobie wylistuje katalog
20141127
wersja 141127-17 odporna na brak plików txt i na złe wpisy w lscNewZip.dat
20141027
Nadal nie wyrzuca plików txt
20141023
błąd - próby przenoszenia plików,
które nie isnieją skutkowały pozostawieniem nieskasowanej listy plików minutowych do sklejania.
Sprawdzam, czy plik do skasowania isnieje
20140822
trzeba gdzieś dodać tworzenie radisk
/opt/zeletronik/c2014p1/ramdisk dowiązany do
/opt/zeletronik/ramdisk/c2014p1
IOError: [Errno 2] No such file or directory: '/opt/zeletronik/c2014p1ramdisk/glue.txt'
na oko cDir odpowiada cDir
zamieniam cDir na cDir

20121011 0.2.13

abezpieczenie całego pliku sumą kontrolną

slejanie zipowanie i szyfrowanie plików txt
20121002



20120927 0.2.04
wstawienie txtFtpOn
class cPaths:
    generacja sciezek dla licznika - creating pats for counrer 
    def __init__(self,argv):
        self.binPathName=argv[0]
        self.binPath=os.path.dirname(self.binPathName)#katalog wywołania skryptu bin
        self.mainPath=os.path.dirname(self.binPath)#katalog nadrzędnywywołania skryptu
        self.scriptName=os.path.basename(self.binPathName).split('.')[0]#nazwa pliku skryptu
        self.namePrefix = sys.argv[1]#nazwa licznika
        self.firmName= argv[2]#katalog z licznkami
        if self.firmName[0]==rootDir:#scieżka bezwzględna
            self.firmDir=self.firmName
        else:
            self.firmDir=os.path.join(self.binPath,'..',self.firmName)#katalog firmowy
        self.cDir=os.path.join(self.firmDir, self.namePrefix)#katalog licznika
        self.outDir=os.path.join(self.cDir,'ftpDat')
        self.ramDir=os.path.join(self.cDir,'ramdisk')
        self.datDir=os.path.join(self.cDir,'dat')
        self.repDir=os.path.join(self.cDir,'reports')
        self.datTrashDir=os.path.join(self.cDir,'datTrash')
        self.logDir=os.path.join(self.cDir,'log')
        self.logName=os.path.join(self.logDir,self.namePrefix+'_'+self.scriptName+'.log')
        self.confDir=os.path.join(self.cDir,"conf")
        self.configName=os.path.join(self.confDir ,'%s_lsc.conf' % self.namePrefix)
        self.logLevel=int(argv[3])

'''

#aktualizacja daty

now = datetime.now()
timestamp=now.strftime("%Y%m%d %H:%M ")
dayMinute = int(now.strftime("%H"))*60 +int(now.strftime("%M"))
#print "\n\n\n-----------------------\nilosc argumentow wywolania = ", len(sys.argv)
throwAway=0
pts = cPaths(sys.argv)
logLevel=pts.logLevel
#------------------fukcja debugera
logName = pts.logName

if len(sys.argv)==4:#jeżeli wersja serwerowa
    #tworzenie ścieżek do katalogów
    pts = cPaths(sys.argv)
    logLevel=pts.logLevel
    #------------------fukcja debugera
    logName = pts.logName
    binPathName=sys.argv[0]
    #print "binPathName = "+binPathName
    binPath=os.path.dirname(binPathName)
    #print "binPath = "+binPath
    
    
    namePrefix = sys.argv[1]
    firmName= sys.argv[2]
    firmDir=os.path.join(binPath,'..',firmName)
    #print "firDir = "+ firmDir
    cDir=os.path.join(firmDir, namePrefix)#katalog licznika
    #ftpDir=os.path.join('..',sys.argv[2])
    #cDir=os.path.join(ftpDir, namePrefix)
    outDir=os.path.join(cDir,'ftpDat')
    #outDir katalog do lokalnego zapisywania plikow .dat ściągniętych z serwera
    ramDir=os.path.join(cDir,'ramdisk')
    datDir=os.path.join(cDir,'dat')
    datTrashDir=os.path.join(cDir,'datTrash')
    txtDir=os.path.join(pts.repDir,'minutes')#katalog plików txt
    
    #ftpDir - dla firmy np: letronik
    LogDir=os.path.join(cDir,'log')
    xLog=os.path.join(LogDir,'GFile.txt')
    xtmp=open(xLog,'wb')
    logName=os.path.join(cDir,'log','%s_lscGlue.log' % namePrefix)
    configName=os.path.join(cDir,'conf' ,'%s_lsc.conf' % namePrefix)
    #baseName = "/opt/zeletronik/%s/reports/db/%s_lscGFile.sqlite" % (namePrefix, namePrefix)
    baseName = os.path.join(cDir,'db',"%s_lscGFile.sqlite" % namePrefix)
    



else:



     namePrefix = sys.argv[0]
     namePrefix = string.split(namePrefix,'/')[-1]
     #baseName = baseName[-1]
     namePrefix = string.split(namePrefix,'_')[0]


     #------------------fukcja debugera
     logName = '/opt/zeletronik/%s/log/%s_lscGlue.log' % (namePrefix,namePrefix)


     try:
          flog=open(logName, 'ab')
     except:
          sys.exit("can't open file %s" % logName)


     logLevel= 1
     vl=(flog,logLevel,timestamp,version)
     '''
     def pLog(vl,a=0,tekst='wpis domyśny do logu'):
         global flog, logLevel,logAddress,timestamp
         if logLevel >= a :
             flog.write(timestamp+wersja+' '+str(tekst)+'\n')
             os.fsync(flog)'''
     #-----------------tworzenie słownika konfiguracyjnego z pliku
     cDir='/opt/zeletronik/%s/' % namePrefix
     configName='/opt/zeletronik/%s/conf/%s_lsc.conf' % (namePrefix,namePrefix)
     confDir='/opt/zeletronik/%s/conf/' % namePrefix
     config={}
     try:
          fconf=open(configName,'r')
     except:
          pLog(vl,0,"can't open file "+configName)
          #pLog(vl,0, "Error %s:" % e.args[0])
          sys.exit("can't open file %s " % configName)
     for line in fconf:
         line = string.strip(line)
         if (string.find(line,'#')== -1)&(len(line)>4):
             pLog(vl,4,line)
             parametry=string.split(line,'=')
             pLog(vl,4, parametry)
             parametr=string.strip(parametry[0])
             wartosc=string.strip(parametry[1])
             if wartosc == 'Y':
                 wartosc='y'
             if wartosc == 'N':
                 wartosc= 'n'
             printlog (4, parametr+':'+ wartosc)
             config[parametr]=wartosc





config=confFileDict(configName)
try:
    flog=open(logName, 'ab')
except:
    sys.exit("can't open file %s" % logName)
logLevel =  int(config['logLevel'])
vl=(flog,logLevel,timestamp,version)
ftpInterval = int(config['txtInterval'])
'''
#------------------------txtFtpOn--------------------------------------
#to załatwia monitor
if config['txtFtpOn']=='0':
    pLog(vl,5, "txtFtpOn=0 OFF")
    flog.close()              
    sys.exit(0)#wewnętrzny cron

'''    
#-------------------------ftpInterval------------------------
if(dayMinute % int(ftpInterval)):
    pLog(vl,5, "do transmisji - %d minut" % (int(ftpInterval)-(dayMinute % int(ftpInterval))))
    flog.close()              
    sys.exit(0)#wewnętrzny cron        



#odliczanie czasu do zipowania
pLog(vl,5, "---------------dayMinute = %d--------------------" % dayMinute)


#------------plik za interwał .zip------------------------
nowDateTime="%4d%02d%02d_%02d%02d" %(now.year,now.month,now.day,now.hour,now.minute)
zipFileName=os.path.join(pts.repDir,'zip',"%s_%s" %(pts.namePrefix, nowDateTime))
pLog(vl,6, 'zipFileName = '+zipFileName)


#porzadkowanie listy nowych plikow
newTxtList=os.path.join(pts.repDir,'lscNewTxt.dat' )
try:
    fnc = open(newTxtList,'rb')
except:
    lista_url=[]
    pLog(vl,2, 'nie mogę otworzyć listy plików do zipowania %s' % newTxtList)
    pLog(vl,6,'txtDri = %s' % txtDir)
    newTxt=os.listdir(txtDir)
    if len(newTxt)==0:
        pLog(vl,6,'Brak plików do sklejania')
        flog.close()
        sys.exit(0)    
    newTxt.sort()
    for txtx in newTxt:
        newItem=(os.path.join(txtDir,txtx))
        lista_url.append(newItem)
        pLog(vl,6,newItem)

else:
    newList = fnc.readlines()#jeśli jest wykaz nowych plików
    fnc.close()
    newList.sort()
#fncr = open('/opt/zeletronik/%s/ramdisk/lscNewTxt.dat' % namePrefix, 'wb')
    tmpline=''
    lista_url=[]#nowe pliki do zipowania
    for line in newList:
        if tmpline != line:
            tmpline = line
           # fncr.write(line)
            line=line.replace('\n','')
            lista_url.append(line)
#fncr.close()     


#pLog(vl,6,'pliki do zipowania %s' % str(lista_url))



#aktualizacja daty  
now = datetime.now()
komunikat = '\nIlosc plikow do zipowania = '+str(len(lista_url))
    
pLog(vl,4,komunikat)#zapisywanie do logu
pLog(vl,8,lista_url)

baseList=[]
zipList=''
glueName=os.path.join(ramDir,'glue.txt')
try:
    fglue=open(glueName,'wb')
except:
    pLog(vl,1,"nie mogę otworzyć pliku %s w ramdisk - przerywam pracę." % glueName)
    flog.close()
    sys.exit(1)
adlerBody=''
for xurl in lista_url:
    pLog(vl,6, "bieżący plik %s " % xurl)
    try:
        flaga=os.path.exists(xurl)
    except:
        pLog(vl,6, "zła ścieżka do pliku %s " % xurl)
        continue
    else:
        if flaga:#jak nie isnieje, nie trzeba przenosić    
            
            wyslac = False # jesli True to wyslac i wpisac na liste wysylkowa do przyszlego porownania
            urlPath = string.split(xurl,'\n')[0] #odrzucane znaku konca linii
            #print urlPath
            urlBase = string.split(urlPath,'/')[-1] #wycinanie nazwy raportu.
            baseList.append(urlBase)
            zipList= zipList+urlBase + ' '#lista czystych nazw klejonych plików
            m1=ftpName(xurl) # ftpName - klasa do wyciągania pól z nazwy
            #----------początek sprawdzania pliku
            rekord=[]#do zapisania w bazie
            try:
                g=open(xurl,'rb')#czytanie danych z pliku
            except:
                pLog(vl,3,"nie można otworzyć pliku %s. " % xurl)
                rekord0=[]
            else:
            #rekord.append(godzina)
                rekord0=g.read()#dane z pliku 000000; ;0x80E4;
                g.close()
                rekord0=rekord0.split(';')#['000000', ' ', '0x80E4', '\r\n']
            if len(rekord0)==4:
                try:
                    testStr="%s;%s" % (rekord0[0],rekord0[1])
                except:
                    pLog(vl,3, "zła struktura pliku")
                    rekord.append('0')#number
                    rekord.append('')#ferr
                    rekord.append('C')#cerr
                else:
                    a=adler(testStr) 
                    if(a== rekord0[2]):
                        rekord.append(int(rekord0[0]))#
                        if rekord0[1].find('F')!= -1:
                            rekord.append('F')
                        else:
                            rekord.append('')
                        if rekord0[1].find('C')!= -1:
                            rekord.append('C')
                        else:
                            rekord.append('')
                       
                                            
                    else:
                        pLog(vl,3,"Zła suma kontrolna %s;%s;%s" %(m1.datetime[2:],testStr, a))
                        rekord.append('0')
                        rekord.append('')
                        rekord.append('C')

            else:
                pLog(vl,3, "za krótki plik %s" % xurl)
               #w rekordzie jest już godznina, trzeba dopisać resztę.
                rekord.append('0')
                rekord.append('')
                rekord.append('S')
            glueLine='%s;%s;%s%s' % (m1.datetime[2:],rekord[0],rekord[1],rekord[2])
            glueLine=glueLine+';'  #+adler(glueLine)
            fglue.write(glueLine+'\n')
            adlerBody += (glueLine+'\n')
            pLog(vl,6, glueLine)
        #wyrzucanie plik za plikiem poczas sklejania 20141126 początek
        #przenoszenie zbędnych plików do kosza 20121031
        #if os.path.exists(xurl):#jak nie isnieje, nie trzeba przenosić
            # jak isnieje, zmień datę na datę wyrzucenia
            try:
                os.utime(xurl,None)
            except :
                e = sys.exc_info()[0]
                pLog(vl,3,'błąd =  %s nieudana zmiana daty modyfikacji %s' % (e,xurl))
            else:
                pLog(vl,6,'datę modyfikacji  %s zmieniono' % xurl)
                minTrash=os.path.join(pts.cDir,'trash','minutes',os.path.basename(xurl))
                pLog(vl,6,'ścieżka do kosza %s' % minTrash)
                try:    
                    shutil.move(xurl,minTrash)
                except:
                    e = sys.exc_info()[0]
                    pLog(vl,3,'błąd = %s nieudane wyrzucanie %s' % (e,xurl))
                    throwAway+=1
                else:
                    pLog(vl,6,'plik %s wyrzucono' % xurl)


        #wyrzucanie plik za plikiem poczas sklejania 20141126 koniec    
        #pLog(vl,6,"rekord - %s, rekord0 - %s" %(rekord, rekord0))
        else:
            pLog(vl,6, "bieżący plik %s nie isntnieje" % xurl)
    #----------------koniec sprawdzania pliku zipowanie
pLog(vl,6,'Dane do sumy kontrolnej\n'+adlerBody)    
fglue.write('@'+adler(adlerBody))    
fglue.close()
glue=0
if config['zipTxt']=='y':
    zipFileName=zipFileName+'.zip'
    if config['zipPasswd']=='y':
        fs=open('/root/.intel')
        s=fs.read().replace('\n','')
        fs.close
        #pLog(vl,6, 's='+str(s))
        command='zip %s %s -j -P %s' % (zipFileName,glueName,s)
    else:
        command='zip %s %s -j' % (zipFileName,glueName)
    pLog(vl,6, command)
    wyj=commands.getoutput(command)
    #print wyj
    if (wyj.find('adding')!=-1 or wyj.find('updating')!=-1) and wyj.find('error')==-1:
        glue=1
        
else:
    zipFileName=zipFileName+'.dat'
    pLog(vl,6, '%s, %s' % (glueName, zipFileName))
    try:
        shutil.copyfile(glueName,zipFileName)
    except:
        pLog(vl,1, "sklejanie nieudane %s" % zipFileName)
    else:
        pLog(vl,6, 'sklejone bez kompresji')
        glue=1
'''if glue:#coś sklejono
    throwAway=0
    #przenoszenie zbędnych plików do kosza 20121031
    pLog(vl,6,"ilość plików na liscie do przeniesienia %d" % len(lista_url))
    for xurl in lista_url:
        if os.path.exists(xurl):#jak nie isnieje, nie trzeba przenosić
            # jak isnieje, zmień datę na datę wyrzucenia
            try:
                os.utime(xurl,None)
            except :
                e = sys.exc_info()[0]
                pLog(vl,3,'błąd =  %s nieudana zmiana daty modyfikacji %s' % (e,xurl))
            else:
                pLog(vl,6,'datę modyfikacji  %s zmieniono' % xurl)
                minTrash=os.path.join(pts.cDir,'trash','minutes',os.path.basename(xurl))
                pLog(vl,6,'ścieżka do kosza %s' % minTrash)
                try:    
                    shutil.move(xurl,minTrash)
                except:
                    e = sys.exc_info()[0]
                    pLog(vl,3,'błąd = %s nieudane wyrzucanie %s' % (e,xurl))
                    throwAway+=1
                else:
                    pLog(vl,6,'plik %s wyrzucono' % xurl)'''

if throwAway==0:     
    lscNewZipDatPath=os.path.join(pts.repDir,'lscNewZip.dat')
    try:
        fo=open(lscNewZipDatPath, 'ab')
    except:
        pLog(vl,3,'Nie mogę otworzyć' % lscNewZipDatPath)
    else:    
        
        fo.write(zipFileName+'\n')
        fo.close()
        #newTxtList=os.path.join(pts.repDir,'lscNewTxt.dat' )
        try:
            os.remove(newTxtList)
        except:
            pLog(vl,3,'błąd - nieudane wyrzucanie %s' % (newTxtList))
        else:
            pLog(vl,6, '***succes')
else:
    pLog(vl,6, 'nie sprzątnięto %d plików' % throwAway)
        

                
        

    
flog.close()

 
