#! /usr/bin/env python
#-*- coding: utf-8 -*-
import os
import sys
import cgitb
sys.stderr = sys.stdout
import subprocess
from datetime import datetime, date, time
import pickle
from lscLib import pLog,confFileDict,cPaths, createDir,subProcIf,ifWork,subProcIfBg,cleanUp,createLink
'''
20150414
jeżeli recordtime (recordCycle)==0 to nie tworzy
i nie wysyła żadnych raportów oprócz sklejonych plików
20150410
Wysyłanie plików dat
20150407
gpio
20150402
ctsPy
Skrypt sterowania systemem w wersji wwws-rsc
20150218
Dodanie maksymalnego przyrostu na minutę, maxDelta
def confDefault(name,default):
20150217
#RSport=(confItem(vl,'portname')) w rs232
20150216
#RSport=(confItem(vl,'portname')) w rs485
20150213
dodanie dynIP
20141209-16
odnowienie tel232
20141208-10
Wprowadzenie tel 485
sudo /opt/zeletronik/bin/lscCounter.py  tel485a /opt/zeletronik

wprowadzenie confItem()
20141121 - problem z cts, rozwiązanie os.system(cts....)
20141021 - dodawanie licznika o460 - 232.c
20141002_10 - dodawanie konfiguracji install i licznika
20141002
wstawianien y=subProcIf(cmd,1)
20141001
Problemy z ftp - dodanie logowania
20140825
dodanie tworzenia katalogu ramdisk
/opt/zeletronik/ramdisk/c2014p1
wywołanie:
start.py namePrefix firmName.
namePrefix - nazwa pliku licznika
firmName - nazwa katalogu firmy/licznika
'''


#print "Content-Type: text/html\n\n"


date='20150416'
revision='03'
__version__=date+'_'+revision

now = datetime.now()
dayMinute = int(now.strftime("%H"))*60 +int(now.strftime("%M"))
timestamp=now.strftime("%Y%m%d %H:%M ")
#tworzenie ścieżek do katalogów
'''
class cPaths:
    """generacja sciezek dla licznika - creating pats for counrer """
    def __init__(self,argv):
        self.binPathName=argv[0]
        self.binPath=os.path.dirname(self.binPathName)#katalog wywołania skryptu bin
        self.mainPath=os.path.dirname(self.binPath)#katalog nadrzędnywywołania skryptu
        self.scriptName=os.path.basename(self.binPathName).split('.')[0]#nazwa pliku skryptu
        self.namePrefix = sys.argv[1]#nazwa licznika
        self.firmName= argv[2]#katalog z licznkami
        if self.firmName[0]==rootDir:#scieżka bezwzględna
            self.firmDir=self.firmName
        else:
            self.firmDir=os.path.join(self.binPath,'..',self.firmName)#katalog firmowy
        self.cDir=os.path.join(self.firmDir, self.namePrefix)#katalog licznika
        self.outDir=os.path.join(self.cDir,'ftpDat')
        self.ramDir=os.path.join(self.cDir,'ramdisk')
        self.datDir=os.path.join(self.cDir,'dat')
        self.repDir=os.path.join(self.cDir,'reports')
        self.datTrashDir=os.path.join(self.cDir,'datTrash')
        self.logDir=os.path.join(self.cDir,'log')
        self.logName=os.path.join(self.logDir,self.namePrefix+'_'+self.scriptName+'.log')
        self.confDir=os.path.join(self.cDir,"conf")
        self.configName=os.path.join(self.confDir ,'%s_lsc.conf' % self.namePrefix)
        if len(argv)==4:
            self.logLevel=int(argv[3])
        else:
            self.logLevel=8
'''

if len(sys.argv)!=3:
    print "brak argumentów"
    sys.exit("brak argumentów")

pts = cPaths(sys.argv)    
binPath=pts.binPath
print "binPath = "+binPath
namePrefix = pts.namePrefix
firmName=pts.firmName
firmDir=pts.firmDir
print "firmDir = "+ firmDir
'''
ramDirName=os.path.join (pts.firmDir,'ramdisk',namePrefix)
clNews= "ramDirName " + ramDirName +'\n'
#print ramDirName
#print createDir(ramDirName)
clNews +="create ramDir "+ createDir(ramDirName)+"\n"
'''
print 'install.conf'
#nawa pliku konfiguracyjnego intalacji
instalConfName=os.path.join(firmDir,'conf','install.conf')

print instalConfName
clNews = "instalConfName "+instalConfName+"\n"   

cDir=os.path.join(firmDir, namePrefix)#katalog licznika
confDir=os.path.join(cDir,"conf")
logName=os.path.join(cDir,'log','%s_lscCounter.log' % namePrefix)



#clNews=''

    #-------odczytywanie listy liczników      
        
############## I generates the configuration dictionary /Generuję słownik kofiguracji /       
pickleName=os.path.join(confDir,"%s_conf.pickle" % ( namePrefix))

pickleOK=False

if os.path.exists(pickleName):

    try:
        fpl=open(pickleName,'rb')
    except:
        clNews+="nie mogę otworzyć %s" % pickleName
    else:
        try:
            config=pickle.load(fpl)
        except:
            pass
        else:
            pickleOK=True
            clNews+="configuraja odczytana z pickle"
        fpl.close()         
            
print pickleOK

if not pickleOK:
        

    #----------wczytwyanie konfiguracji

    #config={}
    #stanDnia = 0
    #    configName = os.path.join (confDir,namePrefix+'_lsc.conf')
    config=confFileDict(instalConfName)
    #print config
    config.update(confFileDict(pts.configName))
    #print "\n\n\n",config
    clNews+="configuraja odczytana z pliku.conf <br>\n"

    #---------configuracja wczytana
    #zapisywanie konfiguracji do pickle
    try:
        fp=open(pickleName,'wb')
    except:
        clNews+="nie mogę otworzyć %s" % pickleName
    else:
        try:
            pickle.dump(config,fp)
        except:
            pass
        else:
            clNews+="Pickle utworzone %s" % pickleName
            
        fp.close()

print clNews 
logLevel =  6
try:
     flog=open(logName, 'ab')
except:
     sys.exit("can't open file %s" % logName)
     
vl=(flog,logLevel,timestamp,__version__)
def confItem(vl,name):
    try:
        value=config[name]
    except:
        pLog(vl,1,"Błąd konfiguracji dla klucza %s" % name)
        vl[0].close()
        sys.exit(1)
    else:
        return value
    
def confDefault(name,default):
    err=0
    try:
        value=config[name]
    except:
        value=default
        err="Błąd konfiguracji dla klucza %s, podstawiono %s" % (name,str(value))
    return (value,err)
    
logLevel =  int(confItem(vl,'logLevel'))        
pLog(vl,3,"-----------Start przetwarzania logLevel=%s" % logLevel)
pLog(vl,3,clNews)

ramDirName=os.path.join (pts.firmDir,'ramdisk',namePrefix)
#print ramDirName
#print createDir(ramDirName)

ramdiskPath=os.path.join(firmDir,'ramdisk')
cRamdisk=os.path.join(ramdiskPath,namePrefix)
pLog(vl,3,"createRamDisk %s" % createDir(cRamdisk))
cRamdiskLink=os.path.join(cDir,'ramdisk')
pLog(vl,3, 'cRamdisk = %s,ramdiskLink=%s' % (cRamdisk, cRamdiskLink))
pLog(vl,3, " createDirInfo = %s" % createDir(cRamdisk))
out=createLink(cRamdisk, cRamdiskLink)
pLog(vl,3,"createLinkInfo = %s" % str(out))
#cmd = "/usr/sbin/ntpclient -i 600 -s -l -D -p 123 -h 0.pl.pool.ntp.org &"
maxDelta=confDefault('maxDelta',250)
pLog(vl,3, " maxDelta  = %s" % str(maxDelta))
maxDelta=int(maxDelta[0])
arch=confItem(vl,'arch')
cType=(confItem(vl,'cType'))
cmdLogLev=0
if logLevel>2:
    cmdLogLev=1
if logLevel>5:
    cmdLogLev=2
#####uruchamianie licznika CTS
if cType=='cts':
    command=os.path.join(binPath,'lscCts%s' % arch)
    #cmd=[command,namePrefix, pts.firmName,config['portname'], config['activeTime'],config['passiveTime'],config['slope'], str(logLevel)]
    scmd=cmd=command+' '+namePrefix+' '+pts.firmName+' '+confItem(vl,'portname')# do sprawdzania ps axu
    cmd=scmd+' '+confItem(vl,'activeTime')+' '+confItem(vl,'passiveTime')+' '+confItem(vl,'slope')+' '+str(logLevel)+ ' &'#do wykonania
    print 'ctsCommand = ', cmd
    pLog(vl,6,'ctsCommand -> %s' % str(cmd))
    #y=subProcIfBg(cmd,cmdLogLev)
    #pLog(vl,6,"wynik odczytu cts\n %s" %str(y))
    if ifWork(scmd):
         pLog(vl,6,'cts dziala')
    else:
         pLog(vl,6,'cts nie dziala, uruchomie')
         os.system(cmd)
         pLog(vl,6,'cts wlasnie uruchomilem')
         
#####Licznik na Cts na pythonie pyser
if cType=='ctsPy':
    

    command=os.path.join(binPath,'lscCtsPy.py')
    cmd=['python',command,namePrefix, pts.firmName,str(logLevel),confItem(vl,'portname'),\
confItem(vl,'activeTime'),confItem(vl,'passiveTime'),confItem(vl,'slope')]
    pLog(vl,6,'Liczenie na porcie COM: \n%s' % str(cmd))
    y=subProcIf(cmd,1)
    pLog(vl,6,"wynik odczytu\n %s" %str(y))        
        
#####Licznik na portach gpio Rpi


if cType=='gpio':
    command=os.path.join(binPath,'lscGpio.py')
    cmd=['python',command,namePrefix, pts.firmName,str(logLevel),confItem(vl,'gpioNo'),\
confItem(vl,'activeTime'),confItem(vl,'passiveTime'),confItem(vl,'slope')]
    pLog(vl,6,'Liczenie na porcie gpio: \n%s' % str(cmd))
    y=subProcIf(cmd,1)
    pLog(vl,6,"wynik odczytu\n %s" %str(y))   


#####Odczytywanie interfejsu rs485
if cType=='485':
    
    RSport=(confItem(vl,'portname'))
    RSaddress=(confItem(vl,'adr485'))
    RSregister=(confItem(vl,'reg485'))
    command=os.path.join(binPath,'lscIn.py')
    cmd=['python',command,namePrefix, pts.firmName,str(logLevel),RSport,RSaddress, RSregister]
    pLog(vl,6,'Odczytywanie interfejsu 485: \n%s' % str(cmd))
    y=subProcIf(cmd,1)
    pLog(vl,6,"wynik odczytu\n %s" %str(y))

if cType=='tel232':
    pLog(vl,6,'Odczytywanie interfejsu 232 po telnecie.')
    """
    cRegister=sys.argv[9]
     0              1       2               3 4      5            6     7   8 9 
sudo ./lscTel485.py tel485a /opt/zeletronik 6 telnet 192.168.1.40 12651 1.0 4 C

telnetName = 77.255.60.52
telnetPort=12651
telnetTimeOut=2
"""
    telnetName=(confItem(vl,'telnetName'))
    telnetPort=(confItem(vl,'telnetPort'))
    telnetTimeOut=(confItem(vl,'telnetTimeOut'))
    #RSport=(confItem(vl,'portname'))
    pLog(vl,6,'Odczytywanie interfejsu 232 po telnecie 2.')
    command=os.path.join(binPath,'lscTel232.py')
    pLog(vl,6,'Odczytywanie interfejsu 232 po telnecie 3.')
    #/opt/zeletronik/bin/lscTel232.py namePrefix /opt/zeletronik logLevel host port timeout
    scmd=command+" "+namePrefix+" "+pts.firmName+" "+str(logLevel)+" "+telnetName+" "+telnetPort+" "+telnetTimeOut
    pLog(vl,6,'Odczytywanie interfejsu 232 po telnecie: \n%s' % str(scmd))
    cmd=scmd+' &'#do wykonania
    pLog(vl,6,'start -> %s' % str(cmd))
    if ifWork(scmd):
         pLog(vl,6,'lscTel232.py działa')
    else:
         pLog(vl,6,'lscTel232.py nie działa, uruchomie')
         os.system(cmd)
         pLog(vl,6,'lscTel232.py własnie uruchomilem')
    
    #pLog(vl,6,"wynik odczytu\n %s" %str(y))    


if cType=='tel485':
    """
    cRegister=sys.argv[9]
     0              1       2               3 4      5            6     7   8 9 
sudo ./lscTel485.py tel485a /opt/zeletronik 6 telnet 192.168.1.40 12651 1.0 4 C

telnetName = 77.255.60.52
telnetPort=12651
telnetTimeOut=2
"""
    telnetName=(confItem(vl,'telnetName'))
    telnetPort=(confItem(vl,'telnetPort'))
    telnetTimeOut=(confItem(vl,'telnetTimeOut'))
    #RSport=(confItem(vl,'portname'))
    RSaddress=(confItem(vl,'adr485'))
    RSregister=(confItem(vl,'reg485'))
    command=os.path.join(binPath,'lscTel485.py')
    cmd=['python',command,namePrefix, pts.firmName,str(logLevel),telnetName,telnetPort,telnetTimeOut,RSaddress, RSregister]
    pLog(vl,6,'Odczytywanie interfejsu 485 po telnecie: \n%s' % str(cmd))
    y=subProcIf(cmd,1)
    pLog(vl,6,"wynik odczytu\n %s" %str(y)) 

############### Odczytywanie interfesji rs232 licznika o460
# wywołanie:
#./lscRs232Int64 c2014u0 /opt/zeletronik /dev/ttyUSB0 1 6 &
if cType=='232':
    period='1' #co ile minut czytać licznik, na razie period=1
    command=os.path.join(binPath,'lscRs232%s' % arch)
    #cmd=[command,namePrefix, pts.firmName,confItem(vl,'portname'], period, str(logLevel)]
    scmd=command+' '+namePrefix+' '+pts.firmName+' '+confItem(vl,'portname')+' '+period+' '+str(logLevel)
    cmd=scmd+' &'
    print 'Rs232Command = ', cmd
    pLog(vl,6,'Rs232ShortCommand -> %s' % scmd)
    #y=subProcIfBg(cmd,1)
    #pLog(vl,6,"wynik odczytu Rs232\n %s" %str(y))
    pLog(vl,6,'Rs232Command -> %s' % str(cmd))
    if ifWork(scmd):
         pLog(vl,6,'Rs232 dziala')
    else:
         pLog(vl,6,'Rs232 nie dziala, uruchomie')
         os.system(cmd)
         pLog(vl,6,'Rs232 wlasnie uruchomilem')    

####konwersja tx8ToTxt (pliki minutowe)
if cType=='485' or cType=='232' or cType=='tel485' or cType=='tel232':
    command=os.path.join(binPath,'lscTx8Txt.py')
    cmd=['python',command,namePrefix, pts.firmName,str(logLevel),str(maxDelta)]
    pLog(vl,6,'konwersja tx8ToTxt (pliki minutowe)\n %s' % str(cmd))
    y=subProcIf(cmd,1)
    pLog(vl,6,"wynik konwersji tx8ToTxt = %s" %str(y))

#--------------Sklejanie plików
command=os.path.join(binPath,'lscGlue.py')
cmd=['python',command,namePrefix, pts.firmName,str(logLevel)]
pLog(vl,6,'Sklejanie plików minutowych %s' % str(cmd))
y=subProcIf(cmd,1)
pLog(vl,6,"wynik sklejania = %s" %str(y))

recordCycle=int(confItem(vl,'recordtime'))
if recordCycle>0:
#-------------------------gromadzenie danych lscGFile.py-

    command=os.path.join(binPath,'lscGFile.py')
    cmd=['python',command,namePrefix, pts.firmName, str(logLevel)]
    pLog(vl,6,'Ściąganie i gromadzenie dancych %s' % str(cmd))
    y=subProcIf(cmd,1)
    pLog(vl,6,"wynik  = %s" %str(y))

    #--------------------------UAKTUALNIENIE BAZY MIESIĘCZNEJ

    command=os.path.join(binPath,'lscBase.py')
    cmd=['python',command,namePrefix, firmName, str(logLevel) ]   
    pLog(vl,6,'Uaktualnianie bazy miesięcznej\n %s' % str(cmd))
    y=subProcIf(cmd,1)
    pLog(vl,6,"wynik  = %s" %str(y))

    #-------------------"tworzenie raportu miesięczniego
    command=os.path.join(binPath,'lscMR.py')
    cmd=['python',command,namePrefix, firmName, str(logLevel)]
    pLog(vl,6,'Tworzenie raportu miesięczniego\n %s' % str(cmd))
    y=subProcIf(cmd,1)
    pLog(vl,6,"wynik  = %s" %str(y))

    #-----------------Tworzenie rapotru dziennego---------

    command=os.path.join(binPath,'lscDR.py')
    cmd=['python',command,namePrefix, firmName]
    pLog(vl,6,'Tworzenie raportu dziennego\n %s' % str(cmd))
    y=subProcIf(cmd,1)
    pLog(vl,6,"wynik  = %s" %str(y))


    #--------wysyłanie raportów na ftp

    command=os.path.join(binPath,'lscToFtp.py')
    cmd=['python',command,namePrefix, firmName]   
    pLog(vl,6,'WYSYŁANIE RAPORTÓW CSV NA FTP %s' % str(cmd))
    y=subProcIf(cmd,1)
    pLog(vl,6,"wynik wysyłania = %s" %str(y))



#cmd=['python',0command,1namePrefix, 2firmName,3interval,4localDir,
#5url,6ftpDir 7login 8passwd  9logLevel  10timeOut]
txtFtpOn=confItem(vl,'txtFtpOn')
pLog(vl,6,'WYSYŁANIE RAPORTÓW dat NA FTP txtFtpOn=%s' % txtFtpOn)
if txtFtpOn == 'y':
    command=os.path.join(binPath,'lscToFtp2.py')
    cmd=['python',command,namePrefix, firmName, confItem(vl,'txtInterval'),'zip',confItem(vl,'txtAddress')\
    ,confItem(vl,'txtUser'),confItem(vl,'txtPasswd'),confItem(vl,'txtDir'),\
         str(logLevel),(confItem(vl,'timeOut'))]   
    pLog(vl,6,'WYSYŁANIE RAPORTÓW dat NA FTP %s' % str(cmd))
    y=subProcIf(cmd,1)
    pLog(vl,6,"wynik wysyłania = %s" %str(y))




#---------czyszczenie śmietnika
trashDir=os.path.join(cDir,'trash')
pLog(vl,6,'czyszczenie śmietnika %s' %  trashDir)
trashDays=5
trashMinutes=trashDays*24*60
pLog(vl,6,'trashMinutes %s' %  trashMinutes)
trashOut=cleanUp(trashDir,trashMinutes)
pLog(vl,6,"Usunięto %d plików, wystąpiło %d błędów" % (trashOut[0], trashOut[1]))

#---------czyszczenie raportów
repDir=pts.repDir
pLog(vl,6,'usuwanie starych raportów %s' %  repDir)
trashDays=3
trashMinutes=trashDays*24*60
pLog(vl,6,'trashMinutes %s' %  trashMinutes)
trashOut=cleanUp(repDir,trashMinutes)
pLog(vl,6,"Usunięto %d plików, wystąpiło %d błędów" % (trashOut[0], trashOut[1]))

#---------skracanie logów
maxLogLine=confItem(vl,'maxLogLine')
command=os.path.join(binPath,'lscShortLog.py')
cmd=['python',command,namePrefix, firmName,str(logLevel),maxLogLine]
#print cmd
pLog(vl,6,'Skracanie logów %s' % str(cmd))
flog.close()
y=subProcIf(cmd,1)
try:
     flog=open(logName, 'ab')
except:
     sys.exit("can't open file %s" % logName)
vl=(flog,logLevel,timestamp,__version__)
pLog(vl,6,'Logi skrocone, sukces')
flog.close()
     
#może być problem ze skróceniem tego logu. Dlatego zamykam go powyżej.
#pLog(vl,6,"wynik wysyłania = %s" %str(y))
#flog.close()
#print y
