#! /usr/bin/env python
#-*- coding: utf-8 -*-
import os
import sys
import cgitb
sys.stderr = sys.stdout
import subprocess
from datetime import datetime, date, time
import pickle
from lscLib import pLog,confFileDict,cPaths, createDir,subProc,variableLoad,variableSave,ifWork,fileFromFtpGet,IpFromFtpGet
'''
20150318
ifMTL=False # czy łądować do bazy przy pomocy mTL.py
Wyjątek dla braku dynIp w install.conf
20150213
wywoływanie lscCounter.py w tle
ściąganie IP z serwera
20141217
kroczące logi
20141216
    scmd=command+' None'# do sprawdzania ps axu
    None - próba oszukania axu
20141215
Ładowanie do bazy
20141211
dostosowanie do rpi
Dodanie testowania zegara.
20141209
prefix=prefixx.strip()
Skrypt sterowania systemem w wersji serwerowej - wywyłytania liczników.
Liczniki rozpozna w install.conf który będziew katalogu ../conf
20140926
Nie zakłada ramdysku
20140825
dodanie tworzenia katalogu ramdisk
/opt/zeletronik/ramdisk/c2014p1
wywołanie:
start.py namePrefix firmName.
namePrefix - nazwa pliku licznika
firmName - nazwa katalogu firmy
'''
'''
import subprocess

p = subprocess.Popen(["echo", "hello world"], stdout=subprocess.PIPE)

print p.communicate()

>>>('hello world\n', None)

'''

#print "Content-Type: text/html\n\n"


date='150318'
revision='1'
nuOfLog=60
__version__=date+'_'+revision
full_path = os.path.realpath(__file__)
binDir=(os.path.dirname(full_path))
parentDir=os.path.dirname(binDir)
confDir=os.path.join(parentDir,'conf')
print confDir
now = datetime.now()
dayMinute = int(now.strftime("%H"))*60 +int(now.strftime("%M"))
logNr=dayMinute%nuOfLog#do kroczących logów
timestamp=now.strftime("%Y%m%d %H:%M ")
#tworzenie ścieżek do katalogów
'''
class cPaths:
    """generacja sciezek dla licznika - creating pats for counrer """
    def __init__(self,argv):
        self.binPathName=argv[0]
        self.binPath=os.path.dirname(self.binPathName)#katalog wywołania skryptu bin
        self.mainPath=os.path.dirname(self.binPath)#katalog nadrzędnywywołania skryptu
        self.scriptName=os.path.basename(self.binPathName).split('.')[0]#nazwa pliku skryptu
        self.namePrefix = sys.argv[1]#nazwa licznika
        self.firmName= argv[2]#katalog z licznkami
        if self.firmName[0]==rootDir:#scieżka bezwzględna
            self.firmDir=self.firmName
        else:
            self.firmDir=os.path.join(self.binPath,'..',self.firmName)#katalog firmowy
        self.cDir=os.path.join(self.firmDir, self.namePrefix)#katalog licznika
        self.outDir=os.path.join(self.cDir,'ftpDat')
        self.ramDir=os.path.join(self.cDir,'ramdisk')
        self.datDir=os.path.join(self.cDir,'dat')
        self.repDir=os.path.join(self.cDir,'reports')
        self.datTrashDir=os.path.join(self.cDir,'datTrash')
        self.logDir=os.path.join(self.cDir,'log')
        self.logName=os.path.join(self.logDir,self.namePrefix+'_'+self.scriptName+'.log')
        self.confDir=os.path.join(self.cDir,"conf")
        self.configName=os.path.join(self.confDir ,'%s_lsc.conf' % self.namePrefix)
        if len(argv)==4:
            self.logLevel=int(argv[3])
        else:
            self.logLevel=8



pts = cPaths(sys.argv)





if len(sys.argv)==3:
    binPath=pts.binPath
    print "binPath = "+binPath
    
    namePrefix = pts.namePrefix
    firmName=pts.firmName
    firmDir=pts.firmDir
    print "firmDir = "+ firmDir
    ramDirName=os.path.join (pts.ramDir,namePrefix)
    print ramDirName
    print createDir(ramDirName)
else:
    print "brak argumentów"
    sys.exit("brak argumentów")

   

cDir=os.path.join(firmDir, namePrefix)#katalog licznika
confDir=os.path.join(cDir,"conf")
logName=os.path.join(cDir,'log','%s_lscStart.log' % namePrefix)





    #-------odczytywanie listy liczników      
'''        
############## I generates the configuration dictionary /Generuję słownik kofiguracji /
clNews=''
pickleName=os.path.join(confDir,"startConf.pickle" )
print pickleName
pickleOK=False

if os.path.exists(pickleName):

    try:
        fpl=open(pickleName,'rb')
    except:
        clNews+="nie mogę otworzyć %s" % pickleName
    else:
        try:
            config=pickle.load(fpl)
        except:
            pass
        else:
            pickleOK=True
            clNews+="configuraja odczytana z pickle"
        fpl.close()         
            

if not pickleOK:

    #----------wczytwyanie konfiguracji

    #config={}
    #stanDnia = 0
    configName = os.path.join(confDir,'install.conf')
    print configName
    config=confFileDict(configName)
    clNews+="configuraja odczytana z pliku.conf <br>\n"

    #---------configuracja wczytana
    #zapisywanie konfiguracji do pickle
    try:
        fp=open(pickleName,'wb')
    except:
        clNews+="nie mogę otworzyć %s" % pickleName
    else:
        try:
            pickle.dump(config,fp)
        except:
            pass
        else:
            clNews+="Pickle utworzone %s" % pickleName
            
        fp.close()
#print clNews
'''
install.conf
logLevel = 8
#katalog, w którym będzie katalog bin
binDir = /opt/zeletronik/bin 
#katalog, w którym będą umieszczane katalog liczników
countDir = /opt/zeletronik
#przedrostek nazwy plików licznika
namePrefixs = test1,test2,test3,test4
'''
logName=os.path.join(confDir,'start1m%02d.log' % logNr)
countDir =(config['countDir'])
logLevel =  int(config['logLevel'])
binDir =  (config['binDir'])
namePrefixs =config['namePrefixs'].split(',')
ifMTL=False # czy łądować do bazy przy pomocy mTL.py
if logLevel>0:
    try:
         flog=open(logName, 'wb')
    except:
         sys.exit("can't open file %s" % logName)
         
    vl=(flog,logLevel,timestamp,__version__)
pLog(vl,3,"-----------Start przetwarzania logLevel=%s" % logLevel)
#------------------Synchronizacja zegara dla rpi start
#----blok zatrzymuje program, jeżeli nie jest ustawionyczas.
#arch=='Rpi'
if config['arch'] == 'Rpi':
    #from lscLib import dateTest
    timeOKFile=os.path.join(parentDir,'ramdisk','timeOK')
    timeOK=variableLoad(timeOKFile)
    if timeOK != 'True':
        pLog(vl,3,"Konieczne sprawdzenie konfiguracji zegara")
        import ntplib  
        def ntpTest(server):
            c = ntplib.NTPClient()

            try:
                response = c.request(server, version=3)
                t=response.offset
            except:
                t=10
            return t 
        t1=ntpTest('ntp.nask.pl')
        t2=ntpTest('ntp.icm.edu.pl')
        t3=ntpTest('ntp1.tp.pl')
        dev=0.1
        out='nask %f imc %f ntp1 %f' % (t1,t2,t3)
        print out
        pLog(vl,3,"wynik synchronizacji zegara=%s" % out)


        if abs(t1)>dev and abs(t2)>dev and abs(t3)>dev:
            x= out
        else:
            x= 0
        if x == 0:
            y=(variableSave('True',timeOKFile) == 0)
            if y !=  True:
                pLog(vl,3,"Błąd wpisu do timeOKFile")
                flog.close()
                sys.exit(y)
            else:
                pLog(vl,3,"synchronizacja zegara właśnie sprawdzona, OK")
        else:
            pLog(vl,3,"synchronizacja zegara właśnie sprawdzona, BRAK SYNCHRONIZACJI")
            flog.close()
            sys.exit(x)

    pLog(vl,3,"synchronizacja zegara OK")
pLog(vl,3,clNews)

pLog(vl,3,"logLevel  = %d logNr = %d" % (logLevel,logNr  ))
pLog(vl,3,"countDir ="+ countDir )
pLog(vl,3,"binDir ="+ binDir )

###--------ściąganie IP liczników---------------
try:
    config['dynIp']
except:
    pLog(vl,3,"Brak konfiguracji dla dynIp w install.conf")
else:
    pLog(vl,3,str([config['dynIp'],config['hostName'],config['user'],config['passwd'],config['ftpPath'],config['localPath'],int(config['timeout'])]))
    if config['dynIp']=='y':
        x=IpFromFtpGet(config['hostName'],config['user'],config['passwd'],config['ftpPath'],config['localPath'],int(config['timeout']))
        pLog(vl,3,"Sciąganie IP %d %s" % (x[0],x[1]))       



n=0
if ifMTL:
    pLog(vl,3,"1")
    command=os.path.join(binDir,'mTL.py')
    pLog(vl,3,"2")
    #cmd=[command,namePrefix, pts.firmName,config['portname'], config['activeTime'],config['passiveTime'],config['slope'], str(logLevel)]
    scmd=command+' > %s' % os.path.join(binDir,'../conf/mTLrun.log')# do sprawdzania ps axu
    cmd=scmd+' &'#do wykonania
    pLog(vl,6,'start -> %s' % str(cmd))
    #y=subProcIfBg(cmd,cmdLogLev)
    #pLog(vl,6,"wynik odczytu cts\n %s" %str(y))
    if ifWork(scmd):
         pLog(vl,6,'mTL.py dziala')
    else:
         pLog(vl,6,'mTL.py nie dziala, uruchomie')
         os.system(cmd)
         pLog(vl,6,'mTL.py wlasnie uruchomilem')
pLog(vl,3,"Prefixs = " + str(namePrefixs))
for prefixx in namePrefixs:
    prefix=prefixx.strip()
    n+=1
    pLog(vl,3,"licznik nr %d - %s" % (n,prefix))





    command=os.path.join(binDir,'lscCounter.py')
    #cmd=['python',command,prefix, countDir]
    cmd='python '+command+' '+prefix+' '+countDir+' &'
    pLog(vl,3,"cmd ="+ str(cmd) )
    y=None

    try:
        y=os.system(cmd)
        #p = subprocess.Popen(["echo", "hello world"], stdout=subprocess.PIPE)
    except:
        e = sys.exc_info()[0]
        pLog(vl,3, "blad = %s, odpowiedz = %s" %(str(e), str(y)))
        #cgitb.handler()
        pLog(vl,3," %s nie udało się %s\n" % (str(cmd),str(e)))
    else:
        pLog(vl,3, "%s, odpowiedz = %s  \nOK" %(str(cmd), str(y)))





    
if logLevel>0:    
    flog.close()


